
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// bursting bubbles | platzende blaeschen

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// more variables
float[] sizs;

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
  //////// setup additional data | weitere daten vorbereiten
  calcSiz();
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// basic display modes and calculations | grundsaetzliche darstellung und berechnungen
  background( 255 );
  textAlign( CENTER, CENTER );
  int subdiv = 16;
  float delta_ang = TWO_PI / subdiv;
  float add_ang = map( second(), 0, 60, 0, TWO_PI );
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// calc numerator and text | dividend und text berechnen
    int subnum = int(my_chars[i]) % subdiv;
    //////// depict what's necessary | was notwendig ist darstellen
    fill( 0, 127, 255, sizs[i]*.2 );
    textSize( sizs[i]*.2 );
    text( subnum, my_xs[i], my_ys[i] );
    fill( 0, 127, 255, sizs[i]*.1 );
    stroke( 0, 127, 255, sizs[i] );
    circle( my_xs[i], my_ys[i], sizs[i]*1.2 );
    noFill();
    arc( my_xs[i], my_ys[i], sizs[i], sizs[i], add_ang, add_ang+delta_ang*(subnum+1) );
    //////// bubbles growing, then popping | blaeschen die wachsen und platzen
    //sizs[i] *= 1.05;
    sizs[i] *= 1 + 1.0/subnum * .2;
    if( sizs[i]>width/8 ) sizs[i] = 1;
  }
}

//////// more functions
void calcSiz() {
  sizs = new float[ my_size ];
  for( int i=0; i<my_chars.length; i++ ) {
    sizs[i] = random( 1, width/8 );
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
  //////// more interaction
  if( key==' ' ) calcSiz();
}
